//Biblioteka od serwomechanizmu
#include <Servo.h>
Servo serwo;
#define SERWO_PIN 10
#include <AFMotor.h>
AF_DCMotor motor1(3); //M3 - motor lewy
AF_DCMotor motor2(2); //M2 - motor prawy
int kat = 101 ;
AF_DCMotor motor3(1); //M1 - motor lewy szczotka
AF_DCMotor motor4(4); //M4 - motor prawy szczotka
int przerwa;
#define BUZZER A2
int voltPin = A4; // aku lipo
//Piny od czujnika odleglosci
#define trigPin 9
#define echoPin A1
int przekazniknapiecia = A5;//przekaznik1 podłączamy do pinu A5
#define sensor1 A0 //czujnik TCRT5000


void setup() {
  pinMode(A2, OUTPUT); //Konfiguracja A2 jako wyjście Buzzer  
digitalWrite(A2, LOW); //Cykliczna zmiana stanu wyjścia
        //----------------------------------------
   int odczyt = analogRead(sensor1);//TCRT500
   if(odczyt <= 100)           //jeżeli BRAK PODLOGI
  {
               digitalWrite(BUZZER, 0);
               delay(300);
               digitalWrite(BUZZER, 1);
               delay(100);
               digitalWrite(BUZZER, 0);//wlacz buzzer
               delay(300);               
              
 digitalWrite(przekazniknapiecia, HIGH);    //wylacz przekaznik;
    
  }
  pinMode(przekazniknapiecia, OUTPUT); //przekaznik1 jako wyjście
  digitalWrite(przekazniknapiecia, LOW);    //stan początkowy przekaznika wysoki
  pinMode(sensor1, INPUT);//TCRT500
  Serial.begin(9600);
  Serial.println("Monitorowanie napiecia ponizej 12.6V:");
  pinMode(A3, INPUT_PULLUP); //Przycisk jako wejście
  delay(2000); //paza na ruszenie
pinMode(A2, OUTPUT); //Konfiguracja A2 jako wyjście Buzzer  
digitalWrite(A2, LOW); //Cykliczna zmiana stanu wyjścia
delay(1000);
digitalWrite(A2, HIGH);
 delay(1000);
    //Serwo do pinu 10
  serwo.attach(SERWO_PIN);
  //Serwo na pozycje srodkowa 90 (bo zakres 0-180)
  serwo.write(kat);
  


motor3.setSpeed(130);//prędkość silnika lewego szczotki
motor3.run(FORWARD);//silnik lewy domyślnie do przodu szczotki
motor4.setSpeed(110);//prędkość silnika prawego szczotki
motor4.run(FORWARD);//silnik prawy domyślnie do przodu szczot

  //Konfiguracja pozostalych elementow
  pinMode(BUZZER, OUTPUT);
  digitalWrite(BUZZER, 1); //Wylaczenie buzzera    

  //Czujnik odleglosci
  pinMode(trigPin, OUTPUT); //Pin, do którego podłączymy trig jako wyjście
  pinMode(echoPin, INPUT); //a echo, jako wejście

motor1.run(FORWARD); // jedz prosto
motor2.run(FORWARD);// to jedz prosto
motor1.setSpeed(220);//prędkość silnika prawego
motor2.setSpeed(220);//prędkość silnika lewego
}

void loop() {
  
 int wartosc = analogRead(voltPin); // odczytuję wartość na
  float wolty = (wartosc / 204.8) * 3; // przekształcam wartość na wolty 
 //Serial.println(wolty);
   //Serial.print("CNY70: ");
  //Serial.println(odczyt);
 // delay(500);
  if (wolty < 11.5 )// spadek ponizej Volt uruchamia buzer 
  // - dobrac doswiadczalnie 0.9V offset
{
             digitalWrite(BUZZER, 0);
               delay(200);
               digitalWrite(BUZZER, 1);
               delay(100);
             digitalWrite(BUZZER, 0);
               delay(200);
               digitalWrite(BUZZER, 1);
               delay(100);  
             digitalWrite(BUZZER, 0);
               delay(200);
               digitalWrite(BUZZER, 1);
               delay(100);
             digitalWrite(BUZZER, 0);
               delay(500);
               digitalWrite(BUZZER, 1);
               delay(100);
             digitalWrite(BUZZER, 0);
               delay(200);
               digitalWrite(BUZZER, 1);
               delay(100);
             digitalWrite(BUZZER, 0);
               delay(200);
               digitalWrite(BUZZER, 1);
               delay(100);  
             digitalWrite(BUZZER, 0);
               delay(200);
               digitalWrite(BUZZER, 1);
               delay(100);
             digitalWrite(BUZZER, 0);
               delay(500);
               digitalWrite(BUZZER, 1);
               delay(100);               
               digitalWrite(przekazniknapiecia, HIGH);    //stan początkowy przekaznika niski
}
//----------------------------------------
   int odczyt = analogRead(sensor1);//TCRT500
   if(odczyt <= 100)           //jeżeli BRAK PODLOGI
  {
               digitalWrite(BUZZER, 0);
               delay(300);
               digitalWrite(BUZZER, 1);
               delay(100);
               digitalWrite(BUZZER, 0);//wlacz buzzer
               delay(300);               
              
 digitalWrite(przekazniknapiecia, HIGH);    //stan początkowy przekaznika nis;
    
  }
  //------------------------------------------------------

  //Czy wykryto przeszkode w zakresie 0-30 cm
  if (zmierzOdleglosc() > 20&& digitalRead(A3) == HIGH) {
motor1.run(FORWARD); //Jesli nie, to jedz prosto
motor2.run(FORWARD);//Jesli nie, to jedz prosto
motor1.setSpeed(220);//prędkość silnika prawego
motor2.setSpeed(220);//prędkość silnika lewego
  
  } else {
     //Jesli przeszkoda
     motor1.run(RELEASE);//stop silnika
      motor2.run(RELEASE);//stop silnika
     serwo.write(60); //Skrec czujnikiem w prawo
     delay(800); //Poczekaj 800ms dla ustabilizowania konstrukcji

    //Sprawdz, czy po prawej stronie jest przeszkoda
    if (zmierzOdleglosc() > 20) {
       //Jesli jest pusto
        digitalWrite(BUZZER, 0);
               delay(200);
               digitalWrite(BUZZER, 1);
               delay(200);
motor1.run(BACKWARD);//silnik lewy do tyłu
motor2.run(BACKWARD);//silnik prawy do tyłu
delay(1200);
motor2.run(FORWARD);//obracaj w prawo
motor1.run(RELEASE);//obracaj w prawo
 przerwa = random(500,5000);//losowe obracanie robota
delay(przerwa);
    } else {
      //Jeśli po prawej jest przeszkoda
      serwo.write(160); //Obroc czujnik w lewo
      delay(800); //Poczekaj 800ms dla ustabilizowania konstrukcji

      //Sprawdz, czy po lowej stronie jest przeszkoda
      if (zmierzOdleglosc()  > 20) {
         //Jesli jest pusto
                 digitalWrite(BUZZER, 0);
               delay(100);
               digitalWrite(BUZZER, 1);
               delay(100);
motor1.run(BACKWARD);//silnik lewy do tyłu
motor2.run(BACKWARD);//silnik prawy do tyłu
delay(1200);
motor1.run(FORWARD);//obracaj
motor2.run(RELEASE);//obracaj
przerwa = random(500,5000);//losowe obracanie robota
delay(przerwa);
      } else {
        //Jesli z przodu, z lewej i prawej jest przeszkoda
        digitalWrite(BUZZER, 0);
        delay(500);
        digitalWrite(BUZZER, 1);
        motor1.run(BACKWARD);//silnik lewy do tyłu
        motor2.run(BACKWARD);//silnik prawy do tyłu
        delay(1500);
        motor2.run(FORWARD);//obracaj
        motor1.run(RELEASE);//obracaj
        delay(2500); //Obracaj w lewo przez 400 ms
        //Daj sygnal buzzerem
      }
    }
    //Po sprawdzeniu przeszkod po bokach
    //Ustaw czujnik prosto    
    serwo.write(kat);
  }

  //Opoznienie 100ms, ponieważ nie ma potrzeby sprawdzać przeszkod czesciej
  delay(100); 
}

int zmierzOdleglosc() {
  long czas, dystans;

  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  czas = pulseIn(echoPin, HIGH);
  dystans = czas / 58;

  return dystans;
}
void stopMotors() {

motor1.run(RELEASE);//silnik lewy bieg jałowy
motor2.run(RELEASE);//silnik prawy bieg jałowy
}

